//
// GridDisplay.java
//

import javax.swing.JFrame;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class GridDisplay extends JPanel {
    /*@non_null@*/ protected Grid grid;

    GridDisplay (/*@non_null@*/ Grid grid) {
        this.grid = grid;
        setOpaque (false); // This is necessary to make painting work
    }

    int getRealWidth () {
	return getVisibleRect ().width; //@nowarn Null
    }

    int getRealHeight () {
	return getVisibleRect ().height; //@nowarn Null
    }

    protected int getSquareWidth ()
	//@ensures \result > 0
    {
	int swidth = getRealWidth () / grid.numColumns ();

	if (swidth > 0) {
	    return swidth;
	} else {
	    return 1;
	}
    }

    protected int getSquareHeight () 
	//@ensures \result > 0
    {
        int sheight = getRealHeight () / grid.numRows ();

	if (sheight > 0) {
	    return sheight;
	} else {
	    return 1;
	}
    }

    protected int getHorizontalOffset () {
        int offset = (getRealWidth () - (getSquareWidth () * grid.numColumns ())) / 2;
	return offset;
    }

    protected int getVerticalOffset () {
        int offset = (getRealHeight() - (getSquareHeight () * grid.numRows ())) / 2;
	return offset;
    }
    
    public void paintComponent (Graphics g) throws RuntimeException
    {
	//@ assume g != null;
        int squarewidth = getSquareWidth ();
        int squareheight = getSquareHeight ();

        int hoffset = getHorizontalOffset ();
        int voffset = getVerticalOffset ();

	for (int x = 0; x < grid.numColumns (); x++) {
	    for (int y = 0; y < grid.numRows (); y++) {
		SimObject tmp = grid.grabObjectAt (x, y);
		
		if (tmp == null) {
		    g.setColor (Color.gray.darker ()); //@nowarn Null
		} else {
		    g.setColor (tmp.getColor());
		}
		
		g.fillRect (hoffset + x * squarewidth, 
			    voffset + ((grid.numRows () - 1 - y) * squareheight),
			    squarewidth - 1, squareheight - 1);
	    }
	}
    }
}

